#include <stdio.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <gtk/gtk.h>

void get_volume(int *l, int *r) {

  int mixerfd;
  int mixers;
  int volume;
  int volumeIoctl;

  if ((mixerfd = open("/dev/mixer", O_RDONLY)) < 0)
    perror("Unable to open mixer device");
  if (ioctl(mixerfd, SOUND_MIXER_READ_DEVMASK, &mixers) < 0) {
    perror("Unable to attain master volume");
    volumeIoctl = SOUND_MIXER_READ_VOLUME;
  } else {
    if (mixers & SOUND_MASK_PCM)
      volumeIoctl = SOUND_MIXER_READ_PCM;
    else
      volumeIoctl = SOUND_MIXER_READ_VOLUME;
  }

  if (ioctl(mixerfd, volumeIoctl, &volume) < 0)
    perror("Unable to get volume");

  *r = (volume & 0xFF00) >> 8;
  *l = (volume & 0x00FF);

  close(mixerfd);

}

void set_volume(int l, int r) {

  int mixerfd;
  int mixers;
  int volume;
  int volumeIoctl;

  if ((mixerfd = open("/dev/mixer", O_RDWR)) < 0)
    perror("Unable to open mixer device");
  if (ioctl(mixerfd, SOUND_MIXER_READ_DEVMASK, &mixers) < 0) {
    perror("Unable to attain master volume");
    volumeIoctl = SOUND_MIXER_WRITE_VOLUME;
  } else {
    if (mixers & SOUND_MASK_PCM)
      volumeIoctl = SOUND_MIXER_WRITE_PCM;
    else
      volumeIoctl = SOUND_MIXER_WRITE_VOLUME;
  }

  volume = (r << 8) | l;
  if ((mixerfd != -1) && (volumeIoctl != 0))
    if (ioctl(mixerfd, volumeIoctl, &volume) < 0)
      perror("Unable to set volume");

  close(mixerfd);

}

void scale_set_volume(GtkAdjustment *adj) {

	set_volume(adj->value, adj->value);

}
